#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cmath>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <list>
#include <ctime>
#define MAXN 2048
using namespace std;
typedef int ll;
map <ll, vector <pair <ll, ll> > > segments;
ll n;
double s;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (ll i = 1; i <= n; i++)
    {
        ll x, y, d;
        cin >> x >> y >> d;
        for (ll j = y+d-1; j >= y; j--)
        {
            ll cnt = y+d-1-j;
            ll first = x, last = x+cnt;
            segments[j].push_back(make_pair(first, last));
        }
    }
    for (auto it = segments.begin(); it != segments.end(); it++)
    {
       vector <pair <ll, ll> > curr = it->second;
       sort (curr.begin(), curr.end());
       size_t sz = curr.size();
       long double curr_s = 0;
       if (sz)
       {
           ll l = curr[0].first;
           ll r = curr[0].second;
           for (size_t i = 1; i < sz; i++)
           {
               if (curr[i].first > r)
               {
                   curr_s += r - l + 0.5;
                   s += r - l + 0.5;
                   l = curr[i].first;
                   r = curr[i].second;
               }
               else
                if (curr[i].second > r)
                r = curr[i].second;
           }
           s += r - l + 0.5;
           curr_s += r - l + 0.5;
       }
    }
    cout << s << endl;
}
/*
4
4 2 18
2 6 20
8 12 12
13 21 5
*/
