#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cmath>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <list>
#include <ctime>
#define MAXN 64
using namespace std;
typedef long long ll;
ll n, s;
ll cnt[MAXN][3];
ll euclid(ll a, ll b)
{
    while (b)
    {
        ll r = a % b;
        a = b;
        b = r;
    }
    return a;
}
void extended_euclid(ll a, ll b, ll &x1, ll &y1)
{
    x1 = 1;
    ll x2 = 0;
    y1 = 0;
    ll y2 = 1;
    while (b)
    {
        ll q = a / b;
        ll r = a % b;
        a = b;
        b = r;
        ll t = x2;
        x2 = x1 - q * x2;
        x1 = t;
        t = y2;
        y2 = y1 - q * y2;
        y1 = t;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> s;
    cnt[1][1] = 1;
    cnt[2][2] = 1;
    for (int i = 3; i <= n; i++)
    {
        cnt[i][1] = cnt[i-1][1] + cnt[i-2][1];
        cnt[i][2] = cnt[i-1][2] + cnt[i-2][2];
    }
    ll a = cnt[n][1], b = cnt[n][2];
    ll nod = euclid(a, b);
    if (s % nod) cout << 0 << endl;
    else
    {
        a /= nod;
        b /= nod;
        s /= nod;
        ll x, y;
        extended_euclid(a, b, x, y);
        x *= s;
        y *= s;
        ll l = ceil((long double)(-y) / (long double)(a));
        if ((long double)(-y) / (long double)(a) == -y / a) l++;
        ll r = floor((long double)(x) / (long double)(b));
        if ((long double)(x) / (long double)(b) == x / b) r--;
        if (r - l + 1 <= 0) cout << 0 << endl;
        else cout << r - l + 1 << endl;
    }
}
