#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
const int MAXN = 50;

int N;
int A[MAXN];
bool vis[MAXN];

void read()
{
    cin >> N;
    for (int i = 0; i < N; i++)
        cin >> A[i];
}

int get_sum()
{
    int sum = 0;
    for (int i = 0; i < N; i++)
        sum += A[i];
    return sum;
}

bool is_valid(int sum)
{
    int new_sum = 0;
    sum >>= 1;
    for (int i = 0; i < N; i++)
    {
        if (new_sum == sum)
            return true;
        if (!vis[i])
            new_sum += A[i];
    }
    return (new_sum == sum);
}

void solve()
{
    int sum = get_sum();
    if (!(sum & 1))
        cout << 0 << endl;
    sort(A, A + N);
    int ans = 0;
    for (int i = 0; i < N; i++)
    {
        int new_sum = sum - A[i];
        if (!(new_sum & 1))
        {
            ans += A[i];
            vis[i] = true;
            if (is_valid(new_sum))
            {
                cout << ans << endl;
                return;
            }
            sum -= A[i];
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    memset(vis, false, sizeof(vis));

    read();
    solve();

    return EXIT_SUCCESS;
}
