#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
const int MAXN = 50;

int N;
int A[MAXN];
bool vis[MAXN];
multiset<int> sums;

void read()
{
    cin >> N;
    for (int i = 0; i < N; i++)
        cin >> A[i];
}

int get_sum()
{
    int sum = 0;
    for (int i = 0; i < N; i++)
        sum += A[i];
    return sum;
}

void get_all_sums()
{
    sums.clear();
    multiset<int> tmp;
    for (int i = 0; i < N; i++)
    {
        if (!vis[i])
        {
            tmp.clear();
            tmp.insert(A[i]);
            for (const auto &it : sums)
                tmp.insert(it + A[i]);
            sums.insert(tmp.begin(), tmp.end());
        }
    }
}

void solve()
{
    int sum = get_sum();
    sort(A, A + N);
    int ans = 0;
    for (int i = 0; i < N; i++)
    {
        int new_sum = sum - A[i];
        if (!(new_sum & 1))
        {
            ans += A[i];
            vis[i] = true;
            get_all_sums();
            if (sums.count(new_sum >> 1) == 2)
            {
                cout << ans << endl;
                return;
            }
            sum -= A[i];
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    memset(vis, false, sizeof(vis));

    read();
    solve();

    return EXIT_SUCCESS;
}
