#include <iostream>
#include <vector>

using namespace std;

int n;
const int maxn = 2000;
int sx[maxn];
int sy[maxn];
int sd[maxn];
double ans;

struct csSquare
{
	int x;
	int y;
	bool tri;
};
vector <csSquare> v;

void assignSquares();

int main()
{
	cin >> n;
	for(int i = 0;i < n; ++i)
		cin >> sx[i] >> sy[i] >> sd[i];

	assignSquares();

	for(int i = 0;i < v.size(); ++i)
	{
		if(v[i].tri == 0)
			ans += 1;
		else
			ans += 0.5;
	}
	cout << ans << endl;

	return 0;
}

void assignSquares()
{
	for(int i = 0;i < n; ++i)
	{
		for(int j = 1;j <= sd[i];++j)///y - vertically
		{
			for(int k = 1;k <= sd[i] - j + 1; ++k )///x - horizontally
			{
				///determine the current square
				csSquare t;
				t.x = sx[i] + k - 1;
				t.y = sy[i] + j - 1;
				if(k == sd[i] - j + 1)
					t.tri = 1;
				else
					t.tri = 0;

				///look if that square has already been added
				bool flag = 0;///has this square already been added
				for(int l = 0;l < v.size(); ++l)
				{
					if(v[l].x == t.x && v[l].y == t.y)
					{
						flag = 1;
						if(t.tri == 0)
							v[l].tri = 0;
					}
				}
				if(!flag)///is this vertex isn't in the vector yet
				{
					v.push_back(t);
				}
			}
		}
	}
}
