#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
const int MAXN = 50;

int N;
int A[MAXN];
bool vis[MAXN];
multiset<int> sums;

void read()
{
    cin >> N;
    for (int i = 0; i < N; i++)
        cin >> A[i];
}

int get_sum()
{
    int sum = 0;
    for (int i = 0; i < N; i++)
        sum += A[i];
    return sum;
}

void get_all_sums()
{
    sums.clear();
    multiset<int> tmp;
    multiset<int>::iterator it;
    for (int i = 0; i < N; i++)
    {
        if (!vis[i])
        {
            tmp.clear();
            tmp.insert(A[i]);
            for (it = sums.begin(); it != sums.end(); it++)
                tmp.insert(*it + A[i]);
            sums.insert(tmp.begin(), tmp.end());
        }
    }
}

int get_interval_sum(int x, int y)
{
    int sum = 0;
    for (int i = x; i <= y; i++)
        if (!vis[i])
            sum += A[i];
    return sum;
}

bool is_possible(int x, int sum)
{
    int s1 = 0, s2 = 0;
    for (int i = x; i < N; i++)
    {
        s1 = get_interval_sum(x, i);
        s2 = get_interval_sum(i + 1, N - 1);
        if ((s1 == sum) && (s2 == sum))
            return true;
    }
    return false;
}

bool is_odd_possible(int x, int sum)
{
    int s1 = 0, s2 = 0;
    for (int i = x; i < N; i++)
    {
        s1 = get_interval_sum(x, i);
        s2 = get_interval_sum(i + 1, N - 1);
        if ((s1 == sum) && (s2 == sum + 1))
            return true;
        else if ((s1 == sum + 1) && (s2 == sum))
            return true;
    }
    return false;
}

void solve()
{
    int ans = 0;
    int sum = get_sum();
    sort(A, A + N);
    for (int i = 0; i < N; i++)
    {
        int new_sum = sum - A[i];
        if (!(new_sum & 1) && (is_possible(i, new_sum >> 1)))
        {
            if (new_sum > ans)
            {
                ans = new_sum;
                sum -= A[i];
            }
        }
        else if (is_odd_possible(i, new_sum >> 1))
        {
            if (new_sum > ans)
            {
                ans = new_sum;
                sum -= A[i];
            }
        }
    }
    cout << get_sum() - ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    memset(vis, false, sizeof(vis));

    read();
    solve();

    return EXIT_SUCCESS;
}

