#include<iostream>

using namespace std;

long long dp[50];
bool b[50];

long long solve(long long x)
{
    if(b[x])
        return dp[x];

    b[x]=1;

    if(x==1 || x==2)
    {
        dp[x]=1;
        return dp[x];
    }

    dp[x]=solve(x-1)+solve(x-2);

    //cout<<dp[x]<<" "<<x<<endl;

    return dp[x];
}

void extended_Euclid(long long a,long long b,long long& x,long long& y)
{
    if(b==0)
    {
        x=1;
        y=0;
        return;
    }

    long long x1,y1;

    extended_Euclid(b,a%b,x1,y1);

    x=y1;
    y=x1-(a/b)*y1;
}

int main ()
{
    long long n,s,a,b,x,y;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>s;

    a=solve(n-1);
    b=solve(n-2);

    extended_Euclid(a,b,x,y);

    if(x<y)
    {
        swap(x,y);
        swap(a,b);
    }

    x*=s;
    y*=s;

    //cout<<x<<" "<<y<<" "<<a<<" "<<b<<endl;

    long long t=(-y)/(a)+1;
    x-=b*t;
    y+=a*t;

    if(x<=0)
    {
        cout<<"0"<<endl;
        return 0;
    }

    t=x/b;
    if(x%b!=0)t++;

    cout<<t<<endl;

    return 0;
}
